#include "Principal.h"
#include <iostream>
using std::cout;
using std::cin;
using std::endl;

Principal::Principal() {
	tamanho_grupo = 0;
	grupo = NULL;
}
Principal::~Principal() {
	if (grupo)
		delete[] grupo;
}

void Principal::executar() {

	//cadastra todas as pessoas no vetor grupo
	cadastrarPessoas();

	// Salva o grupo cadastrado em um arquivo
	salvarGrupo();
	cout << "Grupo Salvo! " << endl;
	system("pause");

	// Apaga o grupo
	delete[] grupo;
	grupo = NULL;
	cout << "Vetor de Grupo Deletado! " << endl;
	system("pause");
	// carrega o grupo do arquivo salvo
	carregarGrupo();
	cout << "Grupo recarregado de arquivo" << endl;
	system ("pause");

	//mostrarPessoas();
}

void Principal::cadastrarPessoas() 
{
	cout << "digite o tamanho do grupo: ";
	cin >> tamanho_grupo;
	grupo = new Pessoa[tamanho_grupo];
	// Cadastra as pessoas do grupo
	for (int i = 0; i < tamanho_grupo; i++) 
	{
		system("cls");
		cout << "digite o nome da " << i+1 << "a pessoa: " << endl;
		std::string c_nome;
		cin >> c_nome;
		grupo[i].setNome(c_nome);
		cout << "digite a idade da " << i+1 << "a pessoa: " << endl;
		int c_idade;
		cin >> c_idade;
		grupo[i].setIdade(c_idade);
		cout << "digite o CPF da " << i+1 << "a pessoa: " << endl;
		int c_CPF;
		cin >> c_CPF;
		grupo[i].setCPF(c_CPF);
	}
}


void Principal::mostrarPessoas()
{
	/* system("cls");

	for (int i = 0; i < tamanho_grupo; i++)
	{
		cout << " O nome da " << i + 1 << "a pessoa eh: " << grupo[i].getNome() << endl;
		cout << " Digite a idade da " << i + 1 << "a pessoa: " << grupo[i].getIdade() << endl;
		cout << " Digite o CPF da " << i + 1 << "a pessoa: " << grupo[i].getCPF() << endl;
		cout << endl;
		system("pause");
	} */

	// Mostra as informaes lidas
	system("cls");
	if (grupo)
		for (int i = 0; i < tamanho_grupo; i++)
		{
			cout << "Pessoa n" << i + 1 << " nome: " << grupo[i].getNome()
				<< " idade: " << grupo[i].getIdade() << " CPF: " << grupo[i].getCPF() << endl;
		}
	system("pause");
}


void Principal::salvarGrupo()
{
	// Abre o arquivo
	std::ofstream arquivo;
	arquivo.open("grupo1.dat", ios::binary |ios::out);

	// Escreve o tamanho do grupo
	arquivo.write((char*)&tamanho_grupo, sizeof(tamanho_grupo));

	// Escreve todos os objetos Pessoa
	system("cls");
	for (int i = 0; i < tamanho_grupo; i++)
	{
		grupo[i].gravar(arquivo);
	}

}

void Principal::carregarGrupo()
{
	// Abre o arquivo
	std::ifstream arquivo;
	arquivo.open("grupo1.dat", ios::binary | ios::in);

	// L o tamanho do grupo
	arquivo.read((char*)&tamanho_grupo, sizeof(tamanho_grupo));

	// Aloca espao e l as informaes do arquivo
	grupo = new Pessoa[tamanho_grupo];
	for (int i = 0; i < tamanho_grupo; i++)
	{
		grupo[i].carregar(arquivo);
	}

	mostrarPessoas();
	
}
